
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   6. May 2007  20:02  *************

	processor  16F628
	radix  DEC

	__config 0x3F18

INDF        EQU   0x00
TMR0        EQU   0x01
PCL         EQU   0x02
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
INTEDG      EQU   6
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
INTF        EQU   1
T0IF        EQU   2
INTE        EQU   4
GIE         EQU   7
OPTION_REG  EQU   0x81
T1CON       EQU   0x10
CMCON       EQU   0x1F
RB1         EQU   1
RB2         EQU   2
RB3         EQU   3
RB5         EQU   5
PORTQ       EQU   0x05
lcdport     EQU   0x2B
Blink       EQU   0
Blink_rq    EQU   2
Buzz_rq     EQU   3
Buzz_rq_alt EQU   4
Buzz_rpt    EQU   5
rx_code     EQU   0x2D
disp_code   EQU   0x2F
fuellstand  EQU   0x31
status      EQU   0x32
rx_merkbit  EQU   6
Text        EQU   0x33
Text2       EQU   0x3C
tmr0cpy     EQU   0x45
RX_PIN      EQU   0
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
ms          EQU   0x25
count       EQU   0x27
us          EQU   0x25
count_2     EQU   0x27
data        EQU   0x29
buff        EQU   0x2A
mode        EQU   0x28
__putstr    EQU   0x25
__ps        EQU   0x26
zeile       EQU   0x25
position    EQU   0x26
buff_2      EQU   0x27
i           EQU   0x24
zahl        EQU   0x25
count_3     EQU   0x27
help        EQU   0x28
C1cnt       EQU   0x29
t           EQU   0x28
t_2         EQU   0x28
i_2         EQU   0x29
ton         EQU   0x24
toff        EQU   0x26
count_4     EQU   0x24
tmp         EQU   0x21
blink_cnt   EQU   0x22
buzz_cnt    EQU   0x23
ci          EQU   0x27

	GOTO main

  ; FILE c:\projekte\picsel\lugs\lugs.c
			;/* LUGS Luxus Gasumschalter fuer AEB-Autogas-Steuergeraete          */
			;/*                                                                  */
			;/* (c) C.Schirp  released for non-commercial use                    */
			;/* LCD-Routinen (c) Holger Klabunde mit Anpassungen von mir         */
			;/*                                                                  */
			;/* V1.0 Erstausgabe (ohne Taster, ohne Pieper, ohne Powerdown)      */
			;/* V1.1 Taster, Hintergrundbeleuchtung, Pieper                      */
			;/* V1.2 Bug in do_taste() bereinigt                                 */
			;/* V1.3 rx_code und disp_code getrennt                              */
			;/* V1.4 Taste wird nicht mehr per SW ausgewertet, RA5=Input         */
			;/* V1.5 Startzeit LOW fuer TX_Pin hinzu                             */
			;/* V1.6 Warteroutine auf 1ms getrimmt, Tanksymbole, LCD schneller   */
			;/*       LCD Power vom uC geschaltet                                */
			;/*                                                                  */
			;
			;#include <c:\projekte\picsel\cc5\16F628.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;
			;// interner Reset-Generator
			;#pragma config = 0x3F18
			;// int Res und Brown Out
			;//#pragma config = 0x3F58
			;
			;#define LCD_RS    0b.00010000             //RS-Pin ist Bit4, LCD Register Select
			;#define LCD_CS    0b.01000000             //E-Pin ist Bit6, LCD Chip Select
			;
			;#define BUZZER   	RB2
			;#define BACKLIGHT   	RB5
			;#define TX_PIN 		RB1
			;#define LCD_POWER       RB3
			;
			;#pragma char PORTQ @ PORTA               //PORT auswhlen, DB7-Bit7, DB6-Bit6, DB5-Bit5, DB4-Bit4
			;
			;#define LCDCS_ON() { NOP;  NOP; lcdport|=LCD_CS; PORTQ=lcdport; }
			;#define LCDCS_OFF() { NOP;  NOP; lcdport&=~LCD_CS; PORTQ=lcdport; }
			;#define LCDRS_ON() { NOP;  NOP; lcdport|=LCD_RS; PORTQ=lcdport; }
			;#define LCDRS_OFF() { NOP; NOP; lcdport&=~LCD_RS; PORTQ=lcdport; }
			;
			;#define Wait() Delay1ms(3)
			;
			;//Kommandos fr das LCD-Display
			;#define CLEAR_DISPLAY 0x01
			;#define OFF_DISPLAY   0x08
			;#define CURSOR_OFF    0x0C
			;#define CURSOR_ON     0x0E
			;#define CURSOR_BLINK  0x0F
			;#define SHIFT_LEFT    0x18
			;#define SHIFT_RIGHT   0x1C
			;#define CGRAM_LEN	56  //Anzahl zu bertragender Zeilen ins CGRAM
			;
			;#define K_BLINK	50 	// Zeitkonstante fr blinkende Texte
			;#define K_BUZZ 5	// Zeitkonstante fr Buzzer On
			;
			;
			;/* Variablen */
			;
			;bank0 uns8		lcdport;
			;bank0 uns8 		Blink:1;	// Bitcounter fr LCD-Blinken
			;bank0 uns8		Buzz:1;		// Bitcounter fr Buzzer
			;bank0 uns8      	Blink_rq:1;	// Statustext Blinkend ausgeben
			;bank0 uns8		Buzz_rq:1;	// Beep bei Empfang
			;bank0 uns8		Buzz_rq_alt:1;
			;bank0 uns8		Buzz_rpt:1;	// Piepen wiederholen
			;bank0 uns16  		rx_code;	// Empfangener Code 0000=ungueltig
			;bank0 uns16		disp_code;	// Angezeigter, dekodierter Code
			;bank0 uns8		fuellstand;	// Fuellstand
			;bank0 uns8		status;		// Status
			;bank0 uns8		rx_merkbit:1;	// 1 if RX is Hi BITVARIABLE!
			;bank0 uns8		Text[9];	// Speicher fr erste LCD-Zeile incl Nullterminierung
			;bank0 uns8		Text2[9];	// Speicher fr zweite LCD-Zeile incl Nullterminierung
			;bank0 uns8		tmr0cpy;
			;bit RX_PIN     	@ PORTB.0;	// INT_IN
			;
			;const unsigned char chardefs[] = {
			;//Adresse 1 im Character RAM
			;// Doppleklotz fuer Tankanzeige
			;0x00, 0x00, 0x00, 0x00, 0x00, 0x1b, 0x1b, 0,
			;0x00, 0x00, 0x00, 0x00, 0x1b, 0x1b, 0x1b, 0,
			;0x00, 0x00, 0x00, 0x1b, 0x1b, 0x1b, 0x1b, 0,
			;0x00, 0x00, 0x1b, 0x1b, 0x1b, 0x1b, 0x1b, 0,
			;0x00, 0x1b, 0x1b, 0x1b, 0x1b, 0x1b, 0x1b, 0,
			;// Leer-Symbol
			;0x11, 0x11, 0x11, 0x11, 0x11, 0x1F, 0x1F, 0x0,
			;// Voll-Symbol
			;0x11, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x0,
			;
			;};
			;
			;void ClrText(void);
			;/*------------------------------------------------------------------*/
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*------------------------------------------------------------------*/
			;
			;
			;#pragma origin 4
	ORG 0x0004
			;interrupt int_server( void)
			;{
int_server
			;    int_save_registers    // W, STATUS (and PCLATH)
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;
			;    if (INTF)
	BTFSS 0x0B,INTF
	GOTO  m003
			;    {
			;        /* RB0/INT interrupt */
			;        rx_merkbit = !RX_PIN;
	BSF   0x2C,rx_merkbit
	BTFSC 0x06,RX_PIN
	BCF   0x2C,rx_merkbit
			;        INTF = 0;
	BCF   0x0B,INTF
			;        if (rx_merkbit)     // request interrupt on next edge (up or down)
	BTFSS 0x2C,rx_merkbit
	GOTO  m001
			;           INTEDG = 1; // if 1, then interrupt on rising edge
	BSF   0x03,RP0
	BSF   0x81,INTEDG
			;        else
	GOTO  m002
			;           INTEDG = 0; // is part of OPTION_REG, is 1 on reset
m001	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x81,INTEDG
			;
			;        /* finish and restart TMR0 */
			;        tmr0cpy = TMR0;
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	MOVWF tmr0cpy
			;        TMR0 = 0;
	CLRF  TMR0
			;        T0IF = 1; // end polling wait-loop, similar to TRM0 wraparound
	BSF   0x0B,T0IF
			;    }
			;
			;   /*
			;     NOTE: GIE is AUTOMATICALLY cleared on interrupt entry and set
			;           to 1 on exit (by RETFIE). Setting GIE to 1 inside the
			;           interrupt service routine will cause nested interrupts
			;           if an interrupt is pending. Too deep nesting may crash
			;           the program !
			;   */
			;
			;    int_restore_registers // W, STATUS (and PCLATH)
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;
			;void init ()
			;{
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ci
	BTFSC ci,7
	GOTO  m004
	BCF   0x03,IRP
	MOVWF FSR
	MOVF  INDF,W
	RETURN
m004	MOVLW .238
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF ci,W
	BTFSS 0x03,Carry
	GOTO  m005
	RETLW .0
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PCLATH
	MOVF  ci,W
	ANDLW .127
	ADDWF PCL,1
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .27
	RETLW .27
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .0
	RETLW .0
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .27
	RETLW .0
	RETLW .17
	RETLW .17
	RETLW .17
	RETLW .17
	RETLW .17
	RETLW .31
	RETLW .31
	RETLW .0
	RETLW .17
	RETLW .31
	RETLW .31
	RETLW .31
	RETLW .31
	RETLW .31
	RETLW .31
	RETLW .0
	RETLW .76
	RETLW .32
	RETLW .69
	RETLW .32
	RETLW .69
	RETLW .32
	RETLW .82
	RETLW .32
	RETLW .0
	RETLW .65
	RETLW .85
	RETLW .83
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .0
	RETLW .45
	RETLW .87
	RETLW .65
	RETLW .82
	RETLW .84
	RETLW .69
	RETLW .78
	RETLW .45
	RETLW .0
	RETLW .71
	RETLW .65
	RETLW .83
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .0
	RETLW .66
	RETLW .69
	RETLW .78
	RETLW .90
	RETLW .73
	RETLW .78
	RETLW .32
	RETLW .32
	RETLW .0
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .0
init
			;	/* PORT A, B Config */
			;	CMCON = 0x07;		// kein Komparator
	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF CMCON
			;	
			;	TRISB = 0b0000.0001; 	// Ausgaenge: 1,2,5 Eingaenge: 0
	MOVLW .1
	BSF   0x03,RP0
	MOVWF TRISB
			;	TRISA = 0b0010.0000;	// LCD-Port: PA output, ra5 input
	MOVLW .32
	MOVWF TRISA
			;	
			;	PORTB = 0b0010.0000;	// HINT: erst Direction, dann Wert!
	MOVLW .32
	BCF   0x03,RP0
	MOVWF PORTB
			;	PORTA = 0x00;
	CLRF  PORTA
			;	/*sonstiges*/
			;	T1CON = 0x00;		// Timer disabled
	CLRF  T1CON
			;	OPTION_REG = 0x04;/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW .4
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;
			;
			;	/* Variablen initialisieren */
			;	rx_merkbit = 	0;
	BCF   0x03,RP0
	BCF   0x2C,rx_merkbit
			;	Blink_rq=	0;
	BCF   0x2C,Blink_rq
			;	Buzz_rq=	0;
	BCF   0x2C,Buzz_rq
			;	Buzz_rq_alt = 	0;
	BCF   0x2C,Buzz_rq_alt
			;	
			;
			;	INTCON = 0; 			// reset and disable all interrupts by default
	CLRF  INTCON
			;	INTE = 	1;
	BSF   0x0B,INTE
			;	GIE = 	 1;				// Enable Interrupts
	BSF   0x0B,GIE
			;	
			;	disp_code = 0;
	CLRF  disp_code
	CLRF  disp_code+1
			;	rx_code = 0;
	CLRF  rx_code
	CLRF  rx_code+1
			;	Text[8]=0;
	CLRF  Text+8
			;	Text2[8]=0;
	CLRF  Text2+8
			;	
			;	ClrText();
	GOTO  ClrText
			;}
			;
			;/*------------------------------------------------------------------*/
			;/*   LL    CCCC DDD                                                 */
			;/*   LL   CC    DD DD                                               */
			;/*   LL   CC    DD  DD                                              */
			;/*   LL   CC    DD DD                                               */
			;/*   LLLLL CCCC DDD                                                 */
			;/*------------------------------------------------------------------*/
			;
			;void Delay1ms(uns16 ms)
			;{
Delay1ms
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns8 count;
			; do
			; {
			; 	ms--;	
m006	DECF  ms,1
	INCF  ms,W
	BTFSC 0x03,Zero_
	DECF  ms+1,1
			;	for (count = 0; count < 0x87; count++) // F0
	CLRF  count
m007	MOVLW .135
	SUBWF count,W
	BTFSC 0x03,Carry
	GOTO  m008
			;	{
			;		NOP;	
	NOP  
			;	}
	INCF  count,1
	GOTO  m007
			;}
			;while (ms);
m008	MOVF  ms,W
	IORWF ms+1,W
	BTFSS 0x03,Zero_
	GOTO  m006
			;
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;void Delay100u(uns16 us)
			;{
Delay100u
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns8 count;
			; do
			; {
			; 	us--;	
m009	DECF  us,1
	INCF  us,W
	BTFSC 0x03,Zero_
	DECF  us+1,1
			;	for (count = 0; count < 0x10; count++) // F0
	CLRF  count_2
m010	MOVLW .16
	SUBWF count_2,W
	BTFSC 0x03,Carry
	GOTO  m011
			;	{
			;		NOP;	
	NOP  
			;	}
	INCF  count_2,1
	GOTO  m010
			;}
			;while (us);
m011	MOVF  us,W
	IORWF us+1,W
	BTFSS 0x03,Zero_
	GOTO  m009
			;
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;//*******************************************
			;// Schreibt ein Datenbyte in die LCD-Anzeige
			;// Schreibt das Byte in zwei 4 Bit Nibbles
			;//*******************************************
			;
			;void LCDWriteByte (unsigned char data)
			;{
LCDWriteByte
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF data
			; unsigned char buff;
			; lcdport= PORTQ; 		//alten Wert merken
	MOVF  PORTQ,W
	MOVWF lcdport
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data>>4;   		//High Nibble des Bytes
	SWAPF data,W
	ANDLW .15
	MOVWF buff
			; buff&=0x0F;			//Rest lschen
	MOVLW .15
	ANDWF buff,1
			; lcdport=lcdport&0xF0;		//Hier D0-D3 lschen zum
	MOVLW .240
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom High Nibble
	MOVF  buff,W
	IORWF lcdport,1
			; lcdport|=LCD_CS;
	BSF   lcdport,6
			; LCDCS_ON();	      		//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; buff=data&0x0F;        	//Low Nibble des Bytes
	MOVLW .15
	ANDWF data,W
	MOVWF buff
			; lcdport=lcdport&0xF0;		//D0-D3  lschen zum
	MOVLW .240
	ANDWF lcdport,1
			; lcdport|=buff;			//reinodern vom Low Nibble
	MOVF  buff,W
	IORWF lcdport,1
			; LCDCS_ON();	      		//Low Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			; NOP;
	NOP  
			;}
	RETURN
			;
			;//*****************************************
			;// Commando ans Display senden
			;//*****************************************
			;void LCDCommand(unsigned char mode)
			;{
LCDCommand
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF mode
			; LCDRS_OFF(); 			//Controlregister
	NOP  
	NOP  
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(mode);
	MOVF  mode,W
	CALL  LCDWriteByte
			; LCDRS_ON(); 			//Zurck auf Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			;}
	RETURN
			;
			;//*****************************************
			;// Lscht die LCD Anzeige
			;// Cursor steht dann auf Position 1,Zeile 1
			;// Gilt auch fr mehrzeilige Anzeigen
			;//*****************************************
			;void LCDCls(void)
			;{
LCDCls
			; LCDRS_OFF(); //Controlregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDWriteByte(0x01); //CLS
	MOVLW .1
	CALL  LCDWriteByte
			; LCDRS_ON(); //Umschalten auf Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; Wait();
	MOVLW .3
	MOVWF ms
	CLRF  ms+1
	GOTO  Delay1ms
			;}
			;//**************************************************
			;//Schreibt einen Text in die LCD-Anzeige
			;//**************************************************
			;void LCDString(const char *__putstr)
			;{
LCDString
			;#pragma updateBank 0 /* OFF, all cores */
			; char __ps;
			;
			; __ps = *__putstr;
	MOVF  __putstr,W
	CALL  _const1
	MOVWF __ps
			;
			;  while(__ps>0)
m012	MOVF  __ps,1
	BTFSC 0x03,Zero_
	GOTO  m014
			;   {
			;    __putstr++;
	INCF  __putstr,1
			;    if (__ps== 0) break;
	MOVF  __ps,1
	BTFSS 0x03,Zero_
	GOTO  m013
	GOTO  m014
			;   LCDWriteByte(__ps);
m013	MOVF  __ps,W
	CALL  LCDWriteByte
			;    __ps = *__putstr;
	MOVF  __putstr,W
	CALL  _const1
	MOVWF __ps
			;   }
	GOTO  m012
			;#pragma updateBank 1 /* ON, all cores */
			;}
m014	RETURN
			;//****************************************************
			;// Springt auf Zeile x und Position y der LCD-Anzeige
			;// Gltig fuer 2 Zeilen : 0,1.
			;//****************************************************
			;void LCDPos(unsigned char zeile,unsigned char position)
			;{
LCDPos
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF position
			;#pragma updateBank 0 /* OFF, all cores */
			;	 unsigned char buff;
			;	
			;	// 0x80 wegen Display Adress Set.
			;	// Erste Position ist bei mir  0.
			;	
			;	if (zeile)
	MOVF  zeile,1
	BTFSC 0x03,Zero_
	GOTO  m015
			;	{
			;		buff=0xC0+position;
	MOVLW .192
	ADDWF position,W
	MOVWF buff_2
			;	}
			;	else
	GOTO  m016
			;	{
			;		buff=0x80+position;
m015	MOVLW .128
	ADDWF position,W
	MOVWF buff_2
			;	}
			;	
			;	 LCDCommand(buff);
m016	MOVF  buff_2,W
	GOTO  LCDCommand
			;#pragma updateBank 1 /* ON, all cores */
			;}
			;
			;
			;//*********************************************
			;//Stellt die Funktionsweise der LCD Anzeige ein
			;//*********************************************
			;
			;void LCDInit(void)
			;{
LCDInit
			; int i;
			;//Software Reset laut Hitachi Datenblatt beim KS0066 nicht implementiert
			; Delay1ms(30); //Mglichen Power On Reset abwarten 30ms reichen ab 4,5V
	MOVLW .30
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; 
			; LCDRS_OFF();  //Control Register
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			; LCDCS_OFF();  //LCD-Anzeige abwhlen
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			;
			; /*
			; for(i=0; i<3; i++)
			;  {
			;   lcdport=lcdport&0xF0;//D0-D3 lschen
			;   lcdport|=0x03;	//Wert reinodern
			;   PORTQ=lcdport;	//Auf den Port legen
			;   LCDCS_OFF(); //LCD-Anzeige abwhlen
			;   NOP;
			;   LCDCS_ON();	//High Nibble schreiben
			;   Delay1ms(5); //Ein bichen warten auf die Anzeige
			;  } 
			;  */
			;//Ende Software Reset
			;
			;
			;//Der erste Schreibzugriff nach dem Reset ist ein 8 Bit
			;//Zugriff!! Also nur einmal schreiben, nicht Low-High Nibble.
			;
			;//Um die 4Bit Operation einzuschalten
			; lcdport=0x02;	//4 Bit Operation	
	MOVLW .2
	MOVWF lcdport
			;
			; PORTQ=lcdport;	//Auf den Port legen
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			;
			; LCDCS_ON();	//High Nibble schreiben
	NOP  
	NOP  
	BSF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; NOP;
	NOP  
			; NOP; 
	NOP  
			; LCDCS_OFF();
	NOP  
	NOP  
	BCF   lcdport,6
	MOVF  lcdport,W
	MOVWF PORTQ
			; Delay100u(1);
	MOVLW .1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			; LCDWriteByte(0x2C);    //4 Bit Operation,2 Line,5x7 Font  5
	MOVLW .44
	CALL  LCDWriteByte
			; Delay100u(1);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			; LCDWriteByte(0x14); 	//Cursor Move,Right Shift
	MOVLW .20
	CALL  LCDWriteByte
			; Delay100u(1);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			;
			; LCDWriteByte(0x0C); 	//Display on, Cursor off ,Cursor no blink
	MOVLW .12
	CALL  LCDWriteByte
			; Delay100u(1);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			;
			; LCDWriteByte(0x06); 	//Increment, Display Freeze
	MOVLW .6
	CALL  LCDWriteByte
			; Delay100u(1);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			; LCDWriteByte(0x02); 	//Cursor Home
	MOVLW .2
	CALL  LCDWriteByte
			; Delay100u(1);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF us
	CLRF  us+1
	CALL  Delay100u
			; LCDRS_ON();		//LCD-Datenregister
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   lcdport,4
	MOVF  lcdport,W
	MOVWF PORTQ
			;
			; LCDCommand(CLEAR_DISPLAY);
	MOVLW .1
	CALL  LCDCommand
			; Wait();
	MOVLW .3
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			; 
			; //Die eigenen Character ins CGRAM schreiben
			;
			;//Der interne Adresszhler des LCD-Displays luft
			;//nach jedem Schreibzugriff automatisch hoch
			;
			; LCDCommand(0x48);//CG_RAM Adresse(1) setzen
	MOVLW .72
	CALL  LCDCommand
			;
			; for(i=0; i<CGRAM_LEN; i++) //8 Codes pro Zeichen bertragen
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i
m017	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC i,7
	GOTO  m018
	MOVLW .56
	SUBWF i,W
	BTFSC 0x03,Carry
	GOTO  m019
			;  {
			;   LCDWriteByte(chardefs[i]);
m018	MOVLW .128
	BCF   0x03,RP0
	BCF   0x03,RP1
	ADDWF i,W
	CALL  _const1
	CALL  LCDWriteByte
			;  }
	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i,1
	GOTO  m017
			;
			; LCDCommand(0x80); //DD_RAM Adresse 0 setzen
m019	MOVLW .128
	GOTO  LCDCommand
			;}
			;
			;
			;/*------------------------------------------------------------------*/
			;/*  Konvertiert 16 Bit Binaer zu Hexadezimal-ASCII 4-stellig        */
			;/*------------------------------------------------------------------*/
			;void Dez4Hex(uns16 zahl)
			;{
Dez4Hex
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;	char  count, help;
			;
			;	for (count = 0; count < 4; count++)
	CLRF  count_3
m020	MOVLW .4
	SUBWF count_3,W
	BTFSC 0x03,Carry
	GOTO  m024
			;	{
			;		
			;		help = zahl & 0x000F;
	MOVLW .15
	ANDWF zahl,W
	MOVWF help
			;		
			;		if (help > 9)
	MOVLW .10
	SUBWF help,W
	BTFSS 0x03,Carry
	GOTO  m021
			;		{
			;			Text[3 - count] = help + 0x37;
	MOVF  count_3,W
	SUBLW .3
	ADDLW .51
	MOVWF FSR
	BCF   0x03,IRP
	MOVLW .55
	ADDWF help,W
	MOVWF INDF
			;		}
			;		else
	GOTO  m022
			;		{
			;			Text[3 - count] = help + 0x30;
m021	MOVF  count_3,W
	SUBLW .3
	ADDLW .51
	MOVWF FSR
	BCF   0x03,IRP
	MOVLW .48
	ADDWF help,W
	MOVWF INDF
			;		}
			;		zahl >>=4;
m022	MOVLW .4
	MOVWF C1cnt
m023	BCF   0x03,Carry
	RRF   zahl+1,1
	RRF   zahl,1
	DECFSZ C1cnt,1
	GOTO  m023
			;	}
	INCF  count_3,1
	GOTO  m020
			;#pragma updateBank 1 /* ON, all cores */
			;}
m024	RETURN
			;
			;
			;void ClrText(void)
			;{
ClrText
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;#asm
			;	movlw 32
	MOVLW .32
			;	movwf Text
	MOVWF Text
			;			;	Text[1] = ' ';
			;	movwf Text+1
	MOVWF Text+1
			;			;	Text[2] = ' ';
			;	movwf Text+2
	MOVWF Text+2
			;			;	Text[3] = ' ';
			;	movwf Text+3
	MOVWF Text+3
			;			;	Text[4] = ' ';
			;	movwf Text+4
	MOVWF Text+4
			;			;	Text[5] = ' ';
			;	movwf Text+5
	MOVWF Text+5
			;			;	Text[6] = ' ';
			;	movwf Text+6
	MOVWF Text+6
			;			;	Text[7] = ' ';
			;	movwf Text+7
	MOVWF Text+7
			;
			;#endasm
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;void ClrText2(void)
			;{
ClrText2
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;#asm
			;			
			;	movlw 32
	MOVLW .32
			;			;	Text2[0] = ' ';
			;	movwf Text2
	MOVWF Text2
			;			;	Text2[1] = ' ';
			;	movwf Text2+1
	MOVWF Text2+1
			;			;	Text2[2] = ' ';
			;	movwf Text2+2
	MOVWF Text2+2
			;			;	Text2[3] = ' ';
			;	movwf Text2+3
	MOVWF Text2+3
			;			;	Text2[4] = ' ';
			;	movwf Text2+4
	MOVWF Text2+4
			;			;	Text2[5] = ' ';
			;	movwf Text2+5
	MOVWF Text2+5
			;			;	Text2[6] = ' ';
			;	movwf Text2+6
	MOVWF Text2+6
			;			;	Text2[7] = ' ';
			;	movwf Text2+7
	MOVWF Text2+7
			;
			;#endasm
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*   DDD    EEEEE  CCC                                              */
			;/*   DD DD  E     C                                                 */
			;/*   DD DD  EEE   C                                                 */
			;/*   DD DD  E     C                                                 */
			;/*   DDD    EEEEE  CCC                                              */
			;/*------------------------------------------------------------------*/
			;
			;// 4MHz crystal, 1MHz cycle time, TMR0 prescale=32: timer units of 32 usec.
			;// TRM0 expires at 8 msec.
			;
			;uns8 tmr0wait( void)
			;{
tmr0wait
			;	tmr0cpy = 0xff; // potential longest waiting time, reduced by rx_merkbit
	MOVLW .255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tmr0cpy
			;	while (!T0IF) // wait for TMR0 wrap-around or rx_merkbit
m025	BTFSC 0x0B,T0IF
	GOTO  m026
			;		;
	GOTO  m025
			;
			;	T0IF = 0;
m026	BCF   0x0B,T0IF
			;	return tmr0cpy;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmr0cpy,W
	RETURN
			;}
			;
			;void bogus_code( void)
			;{
bogus_code
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	// just eat rx_merkbit input, as long as we have fast pulses
			;	
			;	uns8 t;
			;
			;	t = 0;
	CLRF  t
			;	while (t < 200)
m027	MOVLW .200
	SUBWF t,W
	BTFSC 0x03,Carry
	GOTO  m028
			;	   t = tmr0wait();
	CALL  tmr0wait
	MOVWF t
	GOTO  m027
			;
			;	rx_code = 0x0000L; // bogus code;
m028	CLRF  rx_code
	CLRF  rx_code+1
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
	RETURN
			;
			;void read_code(void) 
			;{
read_code
			;#pragma updateBank 0 /* OFF, all cores */
			;	// 1 is sequence dark,light:  2x 900us == 2x28
			;	// 0 is sequence light,dark:  2x 900us == 2x28
			;	// frame is: one,one,toggle,11xdata
			;	unsigned char t;
			;	unsigned char i;
			;
			;	t = 0;
	CLRF  t_2
			;	i = 0;
	CLRF  i_2
			;	rx_code = 1L;
	MOVLW .1
	MOVWF rx_code
	CLRF  rx_code+1
			;	while (t < 0xa0)
m029	MOVLW .160
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m032
			;	{
			;	   
			;	   t=tmr0wait(); // low_phase
	CALL  tmr0wait
	MOVWF t_2
			;	   t=tmr0wait(); // high_phase
	CALL  tmr0wait
	MOVWF t_2
			;	   
			;	   if( t  > 0x77 && t  < 0x84)  // High-Bit 4ms
	MOVLW .120
	SUBWF t_2,W
	BTFSS 0x03,Carry
	GOTO  m030
	MOVLW .132
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m030
			;	   {
			;	   	rx_code <<=1;
	BCF   0x03,Carry
	RLF   rx_code,1
	RLF   rx_code+1,1
			;	   	rx_code.0 = 1;
	BSF   rx_code,0
			;	   	i++;
	INCF  i_2,1
			;	   }
			;	   else if( t  > 0x37 && t  < 0x44) // Low-Bit 2ms
	GOTO  m031
m030	MOVLW .56
	SUBWF t_2,W
	BTFSS 0x03,Carry
	GOTO  m031
	MOVLW .68
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m031
			;	   {
			;	   	rx_code <<=1;
	BCF   0x03,Carry
	RLF   rx_code,1
	RLF   rx_code+1,1
			;	   	rx_code.0 = 0;
	BCF   rx_code,0
			;	   	i++;
	INCF  i_2,1
			;	   }
			;
			;	}
m031	GOTO  m029
			;
			;	// code in Ordnung, dann bernehmen
			;	if (i != 13)
m032	MOVF  i_2,W
	XORLW .13
	BTFSC 0x03,Zero_
	GOTO  m033
			;	{
			;		rx_code = 0x0L; // bogus
	CLRF  rx_code
	CLRF  rx_code+1
			;	}
			;	else
	GOTO  m034
			;	{
			;		disp_code = rx_code;
m033	MOVF  rx_code,W
	MOVWF disp_code
	MOVF  rx_code+1,W
	MOVWF disp_code+1
			;	}
			;
			;
			;#pragma updateBank 1 /* ON, all cores */	
			;}
m034	RETURN
			;
			;void get_code( void)
			;{
get_code
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns16 ton;
			;	uns16 toff;
			;
			;    	toff = (uns16)tmr0wait(); // measure first low
	CALL  tmr0wait
	MOVWF toff
	CLRF  toff+1
			;	ton = (uns16)tmr0wait(); // following first high
	CALL  tmr0wait
	MOVWF ton
	CLRF  ton+1
			;
			;
			;    if ((ton  > 0x77) && (ton  < 0x84) &&  // nominal 81 Start Bit immer HIGH!
	MOVF  ton+1,W
	BTFSS 0x03,Zero_
	GOTO  m035
	MOVLW .120
	SUBWF ton,W
	BTFSS 0x03,Carry
	GOTO  m037
m035	MOVF  ton+1,W
	BTFSS 0x03,Zero_
	GOTO  m037
	MOVLW .132
	SUBWF ton,W
	BTFSC 0x03,Carry
	GOTO  m037
			;        (toff > 0x58) && (toff < 0x64))  // nominal 61
	MOVF  toff+1,W
	BTFSS 0x03,Zero_
	GOTO  m036
	MOVLW .89
	SUBWF toff,W
	BTFSS 0x03,Carry
	GOTO  m037
m036	MOVF  toff+1,W
	BTFSS 0x03,Zero_
	GOTO  m037
	MOVLW .100
	SUBWF toff,W
	BTFSC 0x03,Carry
	GOTO  m037
			;	{
			;		read_code();
	CALL  read_code
			;	}
			;	else
	GOTO  m038
			;	{
			;		bogus_code();
m037	GOTO  bogus_code
			;	}
			;
			;#pragma updateBank 1 /* ON, all cores */	
			;}
m038	RETURN
			;
			;void Disp_Status(void)
			;{
Disp_Status
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	LCDPos(0,0); 
	CLRF  zeile
	MOVLW .0
	CALL  LCDPos
			;	Buzz_rq=0;
	BCF   0x2C,Buzz_rq
			;	Buzz_rpt=0;
	BCF   0x2C,Buzz_rpt
			;	Blink_rq = 0;
	BCF   0x2C,Blink_rq
			;	BACKLIGHT = 1;
	BSF   0x06,RB5
			;	switch (status)
	MOVF  status,W
	XORLW .0
	BTFSC 0x03,Zero_
	GOTO  m039
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m042
	XORLW .3
	BTFSC 0x03,Zero_
	GOTO  m043
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m044
	GOTO  m045
			;	{
			;		case 0:		if (disp_code.6)
m039	BTFSS disp_code,6
	GOTO  m040
			;				{
			;					LCDString("L E E R "); Blink_rq = 1; Buzz_rq=1; Buzz_rpt=1;
	MOVLW .184
	MOVWF __putstr
	CALL  LCDString
	BSF   0x2C,Blink_rq
	BSF   0x2C,Buzz_rq
	BSF   0x2C,Buzz_rpt
			;				}
			;				else
	GOTO  m041
			;				{
			;					LCDString("AUS     "); BACKLIGHT = 0; 
m040	MOVLW .193
	MOVWF __putstr
	CALL  LCDString
	BCF   0x06,RB5
			;				}
			;				break;
m041	GOTO  m046
			;		case 1: 	LCDString("-WARTEN-"); Blink_rq = 1; break;
m042	MOVLW .202
	MOVWF __putstr
	CALL  LCDString
	BSF   0x2C,Blink_rq
	GOTO  m046
			;		case 2: 	LCDString("GAS     "); Buzz_rq=1; break;
m043	MOVLW .211
	MOVWF __putstr
	CALL  LCDString
	BSF   0x2C,Buzz_rq
	GOTO  m046
			;		case 3: 	LCDString("BENZIN  "); break;
m044	MOVLW .220
	MOVWF __putstr
	CALL  LCDString
	GOTO  m046
			;		default: 	ClrText(); // Code ausgeben
m045	CALL  ClrText
			;				Dez4Hex(disp_code);
	MOVF  disp_code,W
	MOVWF zahl
	MOVF  disp_code+1,W
	MOVWF zahl+1
	CALL  Dez4Hex
			;				LCDString(Text);
	MOVLW .51
	MOVWF __putstr
	CALL  LCDString
			;				break;			
	GOTO  m046
			;	}
			;	
			;	
			;#pragma updateBank 1 /* ON, all cores */
			;}
m046	RETURN
			;
			;void decode(void)
			;{
decode
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns8 count;
			;	
			;	/* Status */
			;
			;	status = disp_code.low8;
	MOVF  disp_code,W
	MOVWF status
			;	status >>=3;
	BCF   0x03,Carry
	RRF   status,1
	BCF   0x03,Carry
	RRF   status,1
	BCF   0x03,Carry
	RRF   status,1
			;	status &= 0x07;
	MOVLW .7
	ANDWF status,1
			;	
			;	Disp_Status();
	CALL  Disp_Status
			;	
			;	/* Fuellstand berechnen und ausgeben */
			;	ClrText2();
	CALL  ClrText2
			;	
			;	// Fuellstand nur ausgeben wenn Status != 0
			;	if (status)
	MOVF  status,1
	BTFSC 0x03,Zero_
	GOTO  m049
			;	{
			;		Text2[0] = 6;
	MOVLW .6
	MOVWF Text2
			;		Text2[6] = 7;
	MOVLW .7
	MOVWF Text2+6
			;	
			;		fuellstand = disp_code.low8;
	MOVF  disp_code,W
	MOVWF fuellstand
			;		fuellstand &= 0x07;
	MOVLW .7
	ANDWF fuellstand,1
			;		
			;		// Auf max. begrenzen
			;		if (fuellstand > 4)
	MOVLW .5
	SUBWF fuellstand,W
	BTFSS 0x03,Carry
	GOTO  m047
			;			fuellstand = 4;
	MOVLW .4
	MOVWF fuellstand
			;		
			;		fuellstand++;
m047	INCF  fuellstand,1
			;		
			;		// Balken erzeugen
			;		for (count = 1; count <= fuellstand; count++)
	MOVLW .1
	MOVWF count_4
m048	MOVF  count_4,W
	SUBWF fuellstand,W
	BTFSS 0x03,Carry
	GOTO  m049
			;		{
			;			Text2[count]=count;
	MOVLW .60
	ADDWF count_4,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  count_4,W
	MOVWF INDF
			;		}
	INCF  count_4,1
	GOTO  m048
			;	}
			;	
			;	LCDPos(1,0);         
m049	MOVLW .1
	MOVWF zeile
	MOVLW .0
	CALL  LCDPos
			;	LCDString(Text2);
	MOVLW .60
	MOVWF __putstr
	GOTO  LCDString
			;	
			;	
			;	
			;#pragma updateBank 1 /* ON, all cores */	
			;}
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns8 tmp;
			;	uns8 blink_cnt = K_BLINK;
	MOVLW .50
	MOVWF blink_cnt
			;	uns8 buzz_cnt = 0;
	CLRF  buzz_cnt
			;
			;	init();
	CALL  init
			;	
			;	// ca. 18ms fuer Stabilisierung der 5 V, dann TX High
			;	// im Original-16C505 erledigt das der DRT = Device Reset Timer
			;	Delay1ms(10);
	MOVLW .10
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	LCD_POWER = 1;
	BSF   0x06,RB3
			;	
			;	Delay1ms(8);
	MOVLW .8
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	TX_PIN = 1;
	BSF   0x06,RB1
			;	
			;	LCDInit();	  // LCD Initialisieren
	CALL  LCDInit
			;		
			;	// LCDPos(0,0); nicht notwendig, steht nach CLS schon auf 0,0  
			;
			;	while (1)
			;	{
			;		tmp = tmr0wait(); // wrap-around or interrupt, wrap-around takes 8ms
m050	CALL  tmr0wait
	MOVWF tmp
			;
			;
			;	    if (!RX_PIN) //came out of wait by interrupt: RX = Lo => start of new code
	BTFSC 0x06,RX_PIN
	GOTO  m053
			;		{
			;			
			;			get_code();
	CALL  get_code
			;			
			;			if (disp_code != 0)
	MOVF  disp_code,W
	IORWF disp_code+1,W
	BTFSC 0x03,Zero_
	GOTO  m052
			;			{
			;				decode();
	CALL  decode
			;				// Wenn Buzzer-Repeat, Bedingungen zuruecksetzen,
			;				// bei der nchsten Botschaft gibts wieder nen BEEP
			;				if ( Buzz_rpt )
	BTFSS 0x2C,Buzz_rpt
	GOTO  m051
			;				{
			;					Buzz_rq_alt = 0;
	BCF   0x2C,Buzz_rq_alt
			;					Buzz_rq = 0;
	BCF   0x2C,Buzz_rq
			;				}
			;			}
			;			else
m051	GOTO  m053
			;				Blink_rq = 0; // Kein Code empfangen -> nicht blinken!
m052	BCF   0x2C,Blink_rq
			;
			;		}
			;		
			;		// Blinkende Texte darstellen
			;		
			;		blink_cnt--;
m053	DECF  blink_cnt,1
			;		
			;		// erste Zeile blinken lassen, wenn Blink_rq
			;		if (!blink_cnt && Blink_rq)
	MOVF  blink_cnt,1
	BTFSS 0x03,Zero_
	GOTO  m056
	BTFSS 0x2C,Blink_rq
	GOTO  m056
			;		{
			;			Blink ^=1;	// Blinker weiterzaehlen
	MOVLW .1
	XORWF chardefs+44,1
			;			
			;			LCDPos(0,0);
	CLRF  zeile
	MOVLW .0
	CALL  LCDPos
			;			
			;			if (Blink)
	BTFSS 0x2C,Blink
	GOTO  m054
			;			{	
			;				LCDString("        ");
	MOVLW .229
	MOVWF __putstr
	CALL  LCDString
			;			}
			;			else
	GOTO  m055
			;			{
			;				Disp_Status();
m054	CALL  Disp_Status
			;			}
			;			
			;			blink_cnt = K_BLINK;
m055	MOVLW .50
	MOVWF blink_cnt
			;		}
			;		else if (!Blink_rq) // ansonsten Zeitkonstante setzen
	GOTO  m057
m056	BTFSC 0x2C,Blink_rq
	GOTO  m057
			;		{
			;			blink_cnt = K_BLINK;
	MOVLW .50
	MOVWF blink_cnt
			;		}
			;		
			;		// Buzzer
			;		if (Buzz_rq && !Buzz_rq_alt)
m057	BTFSS 0x2C,Buzz_rq
	GOTO  m060
	BTFSC 0x2C,Buzz_rq_alt
	GOTO  m060
			;		{
			;			if (buzz_cnt < 4)
	MOVLW .4
	SUBWF buzz_cnt,W
	BTFSC 0x03,Carry
	GOTO  m058
			;			{
			;				BACKLIGHT = 0;
	BCF   0x06,RB5
			;				BUZZER = 1;
	BSF   0x06,RB2
			;				buzz_cnt++;
	INCF  buzz_cnt,1
			;			}	
			;			else
	GOTO  m059
			;			{
			;				Buzz_rq_alt =1;
m058	BSF   0x2C,Buzz_rq_alt
			;				BUZZER = 0;
	BCF   0x06,RB2
			;				BACKLIGHT = 1;
	BSF   0x06,RB5
			;			}
			;		}
			;		else
m059	GOTO  m061
			;		{
			;			Buzz_rq_alt = Buzz_rq;
m060	BCF   0x2C,Buzz_rq_alt
	BTFSC 0x2C,Buzz_rq
	BSF   0x2C,Buzz_rq_alt
			;			buzz_cnt=0;
	CLRF  buzz_cnt
			;		}
			;		
			;	}
m061	GOTO  m050
			;#pragma updateBank 0 /* OFF, all cores */
			;}
m062	SLEEP
	GOTO main

	END


; *** KEY INFO ***

; 0x0201   10 word(s)  0 % : ClrText
; 0x0004   32 word(s)  1 % : int_server
; 0x00A8   32 word(s)  1 % : init
; 0x00C8   17 word(s)  0 % : Delay1ms
; 0x00D9   17 word(s)  0 % : Delay100u
; 0x00EA   50 word(s)  2 % : LCDWriteByte
; 0x011C   18 word(s)  0 % : LCDCommand
; 0x012E   20 word(s)  0 % : LCDCls
; 0x0142   18 word(s)  0 % : LCDString
; 0x0024  132 word(s)  6 % : _const1
; 0x0154   15 word(s)  0 % : LCDPos
; 0x0163  119 word(s)  5 % : LCDInit
; 0x01DA   39 word(s)  1 % : Dez4Hex
; 0x020B   10 word(s)  0 % : ClrText2
; 0x0215   12 word(s)  0 % : tmr0wait
; 0x0221   11 word(s)  0 % : bogus_code
; 0x022C   53 word(s)  2 % : read_code
; 0x0261   38 word(s)  1 % : get_code
; 0x0287   60 word(s)  2 % : Disp_Status
; 0x02C3   51 word(s)  2 % : decode
; 0x02F6   79 word(s)  3 % : main

; RAM usage: 39 bytes (12 local), 185 bytes free
; Maximum call level: 4 (+1 for interrupt)
; Total of 834 code words (40 %)
